
public aspect HandleWaitingList
{
	
	/*
	 * This pointcut defines the point in the program flow, where reservations are made
	 */
	pointcut makingReservation() :
		// Remember to specify the exact function with correct parameters, when not using wildcards
		execution(public static void ReserveRoomHandler.makeReservation(Room, Person));

	/*
	 * This pointcut defines the point in the program flow, where a customer checks out
	 * and thus when a room becomes available
	 */
	//TODO
	
	// This will catch exactly a NoRoomException
	after() throwing(NoRoomException e) : makingReservation()
	{
		//Code to add customer to waiting list
		GUI.setErrorMessage("Room not available.\nAdding customer to waiting list. (Aspect)");
	}
	
	// This will catch any exception being thrown
	after() throwing() : makingReservation()
	{
		//Code to add customer to waiting list
		System.out.println("No specific exception (after any exception)");
	}
	
	after() : makingReservation()
	{
		System.out.println("Made reservation without any exceptions");
	}
	
}
